package regexFilenameTest;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class RegexFilenameModifier {

	/**
	 * @param args
	 */
	public static void main(String[] args){
		// TODO Auto-generated method stub
		
		String pattern = "第[0-9]+讲";//所要查找的模式
		String pattern2 = "[0-9]+";//pattern中需要替换的部分
		String t1 ="开始第1讲结束第12讲";
		String t2 ="begin第11讲end";
		String t3 ="第021讲";
		String t4 ="haha第讲heihei";
		String t5 = "第1讲哈哈";


		
		System.out.println(modifyString(t1,pattern,pattern2,2));
		System.out.println(modifyString(t2,pattern,pattern2,2));
		System.out.println(modifyString(t3,pattern,pattern2,2));
		System.out.println(modifyString(t4,pattern,pattern2,2));
		System.out.println(modifyString(t5,pattern,pattern2,2));
		
		
		String path1 = "e:\\视频\\教学视频\\Hibernate\\";
		String path2 = "e:\\视频\\教学视频\\Spring\\";
		String path3 = "e:\\视频\\教学视频\\Struts2视频教程\\";
		File file = new File(path3);
		File[] fileList = file.listFiles();
		for(File temp:fileList){
			File x = new File(modifyString(temp.toString(),pattern,pattern2,2));
			temp.renameTo(x);
			//System.out.println("文件名="+temp.getName());
		}
		
		
		
	}
	/**
	 * 返回str中符合pattern的string
	 * @param str
	 * 		  The string to be searched.
	 * @param pattern
	 * 		  The pattern you want to search.
	 * @return The string matched the pattern in the str.
	 */
	public static String getMatchedString(String str,String pattern){
		Pattern pattern1 = Pattern.compile(pattern, Pattern.CASE_INSENSITIVE);
		Matcher matcher = pattern1.matcher(str);
		String match = null;
		if(matcher.find()){
			int start = matcher.start();
			int end = matcher.end();
			 match = str.substring(start,end);
		}
		return match;
	}
	/**
	 * 返回str中符合pattern的string集合
	 * @param str
	 * 	      The string to be searched.
	 * @param pattern
	 *        The pattern you want to search. 
	 * @return The list of string that matched the pattern in the str.
	 */
	public static List<String> getMatchedStrings(String str,String pattern){
		Pattern pattern1 = Pattern.compile(pattern, Pattern.CASE_INSENSITIVE);
		Matcher matcher = pattern1.matcher(str);
		List<String> list = new ArrayList<String>();
		while(matcher.find()){
			int start = matcher.start();
			int end = matcher.end();
			list.add(str.substring(start,end));
		}
		
		System.out.println(list.toString());
		return list;
	}
	
	/**
	 * 在srcStr中找到符合pattern1中集合，然后对该集合中的每个元素找到符合pattern2的字符串temp.
	 * 如果temp字符串的长度>n则不进行任何修改。否则，修改temp字符串，在其前面添加0，直到其长度
	 * 等于n位置
	 * 例子：假设pattern1为 "第1集",pattern2为1,srcStr为 "大汉天子第1集视频",n为3，
	 * 则返回 "大汉天子第001集视频
	 * @param srcStr
	 * 		  The string to be changed.
	 * @param pattern1
	 * 		  The pattern to be searched.
	 * @param pattern2
	 * 		  The pattern, which you want to change, in the pattern2.
	 * @param n
	 * 		  The length of the pattern2 you want to make.
	 * @return The string modified.
	 */
	public static String modifyString(String srcStr,String pattern1,String pattern2, int n){
		
		String tempStr = null;
		//1.get match1
		List<String> matchList = getMatchedStrings(srcStr,pattern1);

		String innerBegin = "";
		String innerEnd = "";
		
		//2.get match2
		String match2 = null;
		List<String> tempList = new ArrayList<String>();
		tempList.add(0, srcStr);
		
		for(String matchx:matchList){
			 match2 = getMatchedString(matchx,pattern2);
			 if (match2.length()>=n)//如果match2长度大于指定的n，则不做任何修改
				 break;
		//	3.change match2 to xxxmatch2
			String[] strArray2 = matchx.split(match2);
			if(strArray2.length == 1){
				innerBegin += strArray2[0]; 
			}
			if (match2.length()<=n){
				if (strArray2.length>=2){
					for(int i = match2.length();i<n;i++ ){
						match2 = "0"+match2;
					}
					innerBegin += strArray2[0];
					innerEnd +=  strArray2[1];
				}
				match2 = innerBegin+match2+innerEnd;
			}
			tempStr = tempList.get(0).replace(matchx, match2);
			tempList.add(0,tempStr);
			
		}//end for
		return tempList.get(0);
		
	}
	
	
	public static String changeStr1(String srcStr,String pattern1,String pattern2, int n) throws IllegalArgumentException{
		
		//1.get match1
		String match1 = getMatchedString(srcStr,pattern1);
		if (match1 == null){
			throw new IllegalArgumentException("'"+srcStr+"' 字符串中不存在 '"+pattern1+"' 模式串");
		}

		String innerBegin = "";
		String innerEnd = "";
		
		//String[] strArray1 = srcStr.split(match1);
		
		//2.get match2
		String match2 = getMatchedString(match1,pattern2);
		//3.change match2 to xxxmatch2
		String[] strArray2 = match1.split(match2);
		if(strArray2.length == 1){
			innerBegin += strArray2[0]; 
		}
		if (match2.length()<=n){
			if (strArray2.length>=2){
				for(int i = match2.length();i<n;i++ ){
					match2 = "0"+match2;
				}
				innerBegin += strArray2[0];
				innerEnd +=  strArray2[1];
			}
			match2 = innerBegin+match2+innerEnd;
		//	System.out.println("before srcStr="+srcStr+" match1="+match1+" match2="+match2);
			
			
		//	System.out.println("after srcStr="+srcStr+" match2="+match2);
			//System.out.println("outerBegin="+outerBegin);
			//return outerBegin+innerBegin+match2+innerEnd+outerEnd;
			
		
		}//如果满足pattern2的match2字符串长度>n，则无需处理match2 
		return srcStr.replace(match1, match2);
		
	}
	
	public static void printStringArray(String[] strArrays){
		for(String s:strArrays){
			System.out.print(s+" ");
		}
		System.out.println("");
	}
	/*假设pattern1为 "第1集"，
	 * pattern2为1,
	 * srcStr为 "大汉天子第1集视频",
	 * n为3，
	 * 则返回 "大汉天子第001集视频*/
	public static String changeStr(String srcStr,String pattern1,String pattern2, int n) throws IllegalArgumentException{
		String match1 = getMatchedString(srcStr,pattern1);
		if (match1 == null){
			throw new IllegalArgumentException("'"+srcStr+"' 字符串中不存在 '"+pattern1+"' 模式串");
		}
		String outerBegin = "";
		String outerEnd = "";
		String innerBegin = "";
		String innerEnd = "";
		
		String[] strArray1 = srcStr.split(match1);
		String match2 = getMatchedString(match1,pattern2);
		String[] strArray2 = match1.split(match2);
		
		if(strArray1.length == 1){
			outerBegin += strArray1[0]; 
		}
		if(strArray2.length == 1){
			innerBegin += strArray2[0]; 
		}
//		System.out.println("outerBegin="+outerBegin);
		if (match2.length()<=n){
			if (strArray1.length>=2 && strArray2.length>=2){
				for(int i = match2.length();i<n;i++ ){
					match2 = "0"+match2;
				}
				outerBegin += strArray1[0];
				outerEnd += strArray1[1];
				innerBegin +=  strArray2[0];
				innerEnd +=  strArray2[1];
			}
			//System.out.println("outerBegin="+outerBegin);
			return outerBegin+innerBegin+match2+innerEnd+outerEnd;
		
		}else{//如果满足pattern2的match2字符串长度>n，则无需处理match2 
			return outerBegin+match1+outerEnd;
		}
	}
}
